if (!Array.prototype.forEach) {
	Array.prototype.forEach = function(lambda, thisObject) {
		for (var i=0 ; i<this.length ; i++) {
			lambda.call(thisObject, this[i]);
		}
	};
}

if (!Array.prototype.map) {
	Array.prototype.map = function(lambda, thisObject) {
		var ret = [];
		for (var i=0 ; i<this.length ; i++) {
			ret.push(lambda.call(thisObject, this[i]));
		}
		return ret;
	};
}

/* Notice: Copied from BO.js */
var BO = new function() {
	var ua = navigator.userAgent.toLowerCase();
	var check = function(r){
		return r.test(ua);
	};

	this.isWindows = check(/windows|win32/);
	this.isMac = check(/macintosh|mac os x/);
	this.isAir = check(/adobeair/);
	this.isLinux = check(/linux/);
	this.X11 = navigator.appVersion.indexOf("X11") !== -1;

	this.opera = check(/opera/);
	this.chrome = check(/chrome/);
	this.webkit = check(/webkit/);

	this.safari = !this.chrome && check(/safari/);
	this.safari20 = this.safari && check(/applewebkit\/4/); // unique to Safari 2
	this.safari30 = this.safari && check(/version\/3/);
	this.safari4 = this.safari && check(/version\/4/);

	this.ie = !this.opera && check(/msie/);
	this.ie7 = this.ie && check(/msie 7/);
	this.ie8 = this.ie && check(/msie 8/);
	// Notice: different from the jslib version;
	this.ie9 = this.ie && check(/msie 9/);
	
	this.ie6 = this.ie && !this.ie7 && !this.ie8 && !this.ie9;

	this.gecko = !this.webkit && check(/gecko/);
	this.gecko2 = this.gecko && check(/rv:1\.8/);
	this.gecko3 = this.gecko && check(/rv:1\.9/);

	// Internet explorer with Chromeframe
	if (this.ie && this.chrome) { // Chromeframe installed
		if (!!window.chrome) { // Chromeframe activated
			this.ie = this.ie6 = this.ie7 = this.ie8 = false;
			this.chrome = this.webkit = true;
		} else {
			this.chrome = this.webkit = false;
		}
	}
};

Cookie = {
	set : function(objHash) {
		cookieString = objHash.name + '=' + escape(objHash.value);
		if (objHash.expires) cookieString += ';expires=' + objHash.expires.toGMTString();
		if (objHash.path) cookieString += ';path=' + objHash.path;
		if (objHash.domain) cookieString += ';domain=' + objHash.domain;
		document.cookie = cookieString;
	},

	get : function(strKey) {
		var retVal = document.cookie.match(new RegExp(strKey + '=([^;$]*)'));
		return (retVal && retVal.length) ? unescape(retVal[1]) : null;
	},

	del : function(objHash) {
		var obj = objHash;
		obj.expires = new Date(0);
		this.set(obj);
	}
};

WebmailEnhancer.prototype = {
	atmail : function() {
		this.form.action = 'https://webmail02.one.com/atmail.pl';
		this.form.target = '_top';

		this.form.usernamehost.value = this.form.login_username.value;
		this.form.password.value = this.form.secretkey.value;
	},

	other : function(action) {
		this.form.action = action;
		this.form.target = '_top';

		this.form.login.value = this.form.login_username.value;
		this.form.password.value = this.form.secretkey.value;
	},

	isAdvancedBrowser : function() {
		return BO.ie6 || BO.ie7 || BO.ie8 || BO.ie9 || BO.gecko || BO.webkit;
	},

	isMobile : function() {
	    // Adapted from http://detectmobilebrowser.com/
    	var nav = navigator.userAgent || navigator.vendor || window.opera;
    	return /android|avantgo|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od|ad)|iris|kindle|lge |maemo|midp|mmp|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(nav) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|e\-|e\/|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|xda(\-|2|g)|yas\-|your|zeto|zte\-/i.test(nav.substr(0,4))
	},

	toggleAdvanced : function() {
		this.advanced = !this.advanced;
		this.advancedImage.className = this.advanced ? 'checked' : '';
		this.advancedCheckbox.checked = this.advanced;
		Cookie.set({
			name : 'advancedWebmail',
			value : this.advanced.toString(),
			path : '/',
			domain : document.location.domain,
			expires : new Date(2020,0)
		});
	},

	loadScreen : function() {
		if (window.loadscreen && document.getElementById('page-container')) {
			var loadScreen = document.createElement('div');
			loadScreen.style.position = 'absolute';
			loadScreen.style.top = '50%';
			loadScreen.style.left = '50%';
			loadScreen.style.width = '514px';
			loadScreen.style.marginTop = '-60px';
			loadScreen.style.marginLeft = '-257px';

			document.body.appendChild(loadScreen);
			document.getElementById('page-container').style.display = 'none';
			loadScreen.innerHTML = window.loadscreen;
		}
	}
};

function WebmailEnhancer(objHTMLFormElement) {
	if (!objHTMLFormElement || this.isMobile()) {
		return false;
	}
	this.form = objHTMLFormElement;

	this.advancedImage = document.getElementById('advanced');
	if (this.advancedImage && BO.ie && this.isAdvancedBrowser()) {
		this.advancedCheckbox = document.getElementById('advancedCheckbox');

		this.advanced = false;
		var cookieSetting = Cookie.get('advancedWebmail');
		if (cookieSetting !== null) {
			if (cookieSetting === 'true') {
				this.toggleAdvanced();
			}
		}

		var This = this;
		this.advancedCheckbox.onclick = function() { This.toggleAdvanced(); };

		// Show
		this.advancedImage.parentNode.className = '';
	}

	var This = this;

	this.form.onsubmit = function() {
		if (!This.form.login_username.value || !This.form.secretkey.value) {
			alert(noWebmailCredentials);
			return false;
		}

		// This.loadScreen();

		try {
			this.XHR = new AjaxRequest({
				'url' : '/webmail.do',
				'synchronous' : true,
				'method' : 'GET',
				'requestHeaders' : {'Content-type' : 'application/x-www-form-urlencoded'},
				'contents' : {
					'email' : trim(This.form.login_username.value),
					'time' : new Date().getTime().toString()
				},
				'onSuccess' : function(objAjaxRequest) {
					var actionNode = objAjaxRequest.xmlhttprequest.responseXML.getElementsByTagName('formhandler')[0];
					var action = actionNode.firstChild && actionNode.firstChild.nodeValue || false;
					if (action) {
						if (This.isAdvancedBrowser() && !/atmail/.exec(action)) {
							This.other(action);
						} else if (This.advanced) {
							if (BO.ie) {
								This.atmail();
							}
						}
					} else {
						// Fallback to squirrel
						return true;
					}
				}
			});

			this.XHR.execute();
		} catch(err) {
			// There is no sane recovery. Fallback to default
		}
	}
}

// Globals
var errors;

/**
  *	initLogin() activates the DHTML popup boxes that are the alternative to the actual login pages.
  *	The popup closes on a click outside its boundaries
  */
var poplinks = ['webmail-link','control-link','webmail-1','control-1']
var login;

function stopEvent(e) {
	if (!e) var e = window.event;
	if (e) {
		e.cancelBubble = true;
		if (e.stopPropagation) e.stopPropagation();
	}
}


function clearInputs() {
	var theForms = login.getElementsByTagName('form');
	for (var i = 0; i < theForms.length; i++) {
		theForms[i].reset();
	}
	if (document.onmousedown) document.onmousedown();
}

function initLogin() {
	login = document.getElementById('onedotcomlogin');
	if (!login) { return false; }

	for (var i = 0, theforms = login.getElementsByTagName('form'); i < theforms.length; i++) {
		Events.attach(theforms[i], 'submit', function() {
			if (window.setTimeout) {
				window.setTimeout(clearInputs,15000);
			}
		});
	}

	// Set link behaviors for links that should use DHTML popup
	for (var i = 0; i < poplinks.length; i++) {
		if (document.getElementById(poplinks[i]) && document.getElementById(poplinks[i].split('-')[0])) {
			document.getElementById(poplinks[i]).onmousedown = function(e) {
				if (document.getElementById('flash')) { // Remove flash while popup exists. flash gets rendered topmost.
					document.getElementById('flash').style.visibility = 'hidden';
				}
				login.className = 'pop_' + this.id.split('-')[0];
				if(document.getElementById(this.id.split('-')[0]).getElementsByTagName('p')[0]) {
					var temp =  document.getElementById(this.id.split('-')[0]).getElementsByTagName('p')[0].getElementsByTagName('input')[0];
					if (temp) { temp.focus(); }
				}
				stopEvent(e);
				return false;
			}

			document.getElementById(poplinks[i]).onclick = function() { return false; }
		}
	}

	login.onmousedown = stopEvent;

	document.onmousedown = function() {
		login.className = '';
		if (document.getElementById('flash')) {
			document.getElementById('flash').style.visibility = 'visible';
		}
	}

	document.getElementById('close').onmousedown = function(e) {
		document.onmousedown();
		return false;
	}
	// TODO: This check might be to unsafe. But it solves the problem
	// with "ugly" stuff in the url.
	if (window.location.href.indexOf('webmail-login-error') != -1 || window.location.href.indexOf('#loginwebmail') != -1 ) {
		document.getElementById('webmail-link').onmousedown();
	}
}
/* initLogin() end */

// Cookie API  v1.0.1
// http://www.dithered.com/javascript/cookies/index.html
// maintained by Chris Nott (chris@NOSPAMdithered.com - remove NOSPAM)

// Write a cookie value
function setCookie(name, value, expires, path, domain, secure) {
	var curCookie = name + '=' + escape(value) + ((expires) ? '; expires=' + expires.toGMTString() : '') + ((path) ? '; path=' + path : '') + ((domain) ? '; domain=' + domain : '') + ((secure) ? '; secure' : '');
	document.cookie = curCookie;
}

function getCookie(name) {
	var dc = document.cookie;

	// find beginning of cookie value in document.cookie
	var prefix = name + "=";
	var begin = dc.indexOf("; " + prefix);
	if (begin == -1) {
		begin = dc.indexOf(prefix);
		if (begin != 0) {
			return null;
		}
	} else {
		begin += 2;
	}

	// find end of cookie value
	var end = document.cookie.indexOf(";", begin);
	if (end == -1) {
		end = dc.length;
	}

	// return cookie value
	return unescape(dc.substring(begin + prefix.length, end));
}

// Delete a named cookie value
function deleteCookie(name, path, domain) {
	var value = getCookie(name);
	if (value != null) {
		document.cookie = name + '=' + ((path) ? '; path=' + path : '') + ((domain) ? '; domain=' + domain : '') + '; expires=Thu, 01-Jan-70 00:00:01 GMT';
	}
	return value;
}

function setValidationMark(fieldIsValid, fieldNameValidation) {
	// Sets the picture on check_[fieldNameValidation] according to validation, red or green
	var imageName = 'check_' + fieldNameValidation;

	if (document.images[imageName]) {
		if (fieldIsValid == false) {
			document.images[imageName].src='/static/images/global/red.gif';
		} else {
			document.images[imageName].src='/static/images/global/green.gif';
		}
	}
}

// Surpresses pressing enter key, so the form does not submit
function noenter(e) {
	if (!e && window.event) {
		var e = window.event;
	}
	if (e && e.keyCode == 13) {
		return false;
	}
	return true;
}

// Hack needed to get Safari to post the form correctly. Doesn't post elements with display: none;
function prepareForm(submitForm, submitName, submitValue) {
	var submitValue = document.createElement("input");
	submitValue.type='hidden';
	submitValue.name=submitName;
	submitValue.value=submitValue; // Optional value to hidden field
	submitForm.appendChild(submitValue);
}

function doupdate(id, show, showClass) {
	if (document.getElementById) {
		obj = document.getElementById(id);
	} else if (document.layers) {
		obj = document.layers[id];
	} else if (document.all) {
		obj = document.all[id];
	} else {
		return;
	}

	if (obj) {
		showClass = showClass != null ? showClass : "show";
		obj.className = show ? showClass : "hide";
	} else {
		return;
	}
}

// Trim whitespace from left and right sides of s.
function trim(s) {
	return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

function validateDomainName(form) {
	var str = trim(form.domainName.value);
	if (str == '' || str.length < 1) {
		errors = errors + domainNotEmpty;
	}
}

function setPopperBehaviour() {
	/*@cc_on
	window.onunload= function() {
		if(document.all) { //Ie only
			if (event.clientY < 0 && Math.abs(event.clientX - document.documentElement.clientWidth) < 100) {
				popper(); // If the event occured in the upper right x area.
			} else if (event.clientY < -5000 && event.clientX < -5000) {
				popper(); // Strange IE6 bug (feature?) when alt+f4 or the x is clicked, clientX and clientY gets very high negative values.
			} else if (event.altKey) {
				popper(); // We assume that alt+f4 was clicked
			}
		}
	}
	@*/
}

function popper() {
	var oldValue = getCookie('call_back');
	if (oldValue == null || oldValue != 'blocked') {
		// Set cookie that expires in one hour
		setCookie('call_back', 'true', new Date((new Date()).getTime() + 3600000));
		var h; var w; var t; var l;
		w = 400;
		h = 320;
		t = (screen.height-h)/2;
		l = (screen.width-w)/2;
		var popwin = window.open('/callback.do','','width='+ w +',height='+ h +',top='+ t +',left='+ l +',location=no, statusbar=no, directories=no, resizable=no, menubar=no, toolbar=no, scrollbars=no');
		if (popwin != null) {
			popwin.focus();
		}
	}
}

// This function will set onclick wndow.open() behavior on links with target="_blank"
function setLinkpopups() {
	var links = document.getElementsByTagName('a');
	for (var i=0;i<links.length;i++) {
		// Trigger on the Advanced Webmail screenshot link
		if (links[i].getAttribute('target') == '_blank' && (links[i].parentNode.className == 'advancedmail' || links[i].className == 'advancedmail')) {
			links[i].onclick = function() {
				window.open(this.href, "INFO", "width=850, height=552, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=no, resizable=no");
				return false;
			}
		}
		// Trigger on the Simple Webmail screenshot link
		else if (links[i].getAttribute('target') == '_blank' && (links[i].parentNode.className == 'simplemail' || links[i].className == 'simplemail')) {
			links[i].onclick = function() {
				window.open(this.href, "INFO", "width=709, height=262, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=no, resizable=no");
				return false;
			}
		}
		// Trigger on the Webcreator link
		else if (links[i].getAttribute('target') == '_blank' && links[i].className == 'info-link-webeditor') {
			links[i].onclick = function() {
				//window.open(this.href, "INFO", "width=720, height=437, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=no, resizable=no");
				window.open(this.href, "INFO", "width=774, height=468, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=no, resizable=no");
				return false;
			}
		}
		// Trigger on the CVC link on the payment page
		else if (links[i].getAttribute('target') == '_blank' && links[i].className == 'cvc') {
			links[i].onclick = function() {
				window.open(this.href, "INFO", "width=400, height=262, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=no, resizable=no");
				return false;
			}
		}
        // Trigger on the ccissuenumber link on the payment page
        else if (links[i].getAttribute('target') == '_blank' && links[i].className == 'ccissuenumber') {
			links[i].onclick = function() {
				window.open(this.href, "INFO", "width=400, height=282, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=no, resizable=no");
				return false;
			}
		}
		// Triggers on info links with target="_blank"
		else if (links[i].getAttribute('target') == '_blank' && links[i].className == 'info-link') {
			links[i].onclick = function() {
				window.open(this.href, 'INFO', 'width=310, height=250, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=yes, resizable=no');
				return false;
			}
		}
	}
}

function applyServicesLargerSizesBehaviour() {
	if (window.groupsObject) {
		var sizeGroup = document.getElementById("sizeGroupContainer").innerHTML;
		var selectedGroup = sizeGroup.substring(sizeGroup.length-1);
		var item1Box = document.getElementById('item1Box');
		var item2Box = document.getElementById('item2Box');
		var item3Box = document.getElementById('item3Box');
		var itemMoreBox = document.getElementById('itemMoreBox');
		if (item1Box && item2Box && item3Box && itemMoreBox) {
			var itemMoreLink = itemMoreBox.getElementsByTagName('a')[0];
			var itemLessLink = itemMoreBox.getElementsByTagName('a')[1];
			if (itemMoreLink && itemLessLink) {
				itemMoreLink.onclick = function() {
					return servicesSizes(true, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
				}
				if (selectedGroup == 0) {
					itemLessLink.onclick = function() {
						return servicesSizes(true, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
					}
				} else {
					itemLessLink.onclick = function() {
						return servicesSizes(false, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
					}
				}
			}
		}
	}
}

function servicesSizes(larger, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox) {
	var item1Container = item1Box.getElementsByTagName('div')[0];
	var item2Container = item2Box.getElementsByTagName('div')[0];
	var item3Container = item3Box.getElementsByTagName('div')[0];
	var itemMoreContainer = itemMoreBox.getElementsByTagName('div')[0];

	var item1Link = item1Box.parentNode;
	var item2Link = item2Box.parentNode;
	var item3Link = item3Box.parentNode;
	var itemMoreLink = itemMoreBox.getElementsByTagName('a')[0];
	var itemLessLink = itemMoreBox.getElementsByTagName('a')[1];

	var globalPrice1Container = document.getElementById('globalPriceButton1');
	var globalPrice2Container = document.getElementById('globalPriceButton2');
	var globalPrice3Container = document.getElementById('globalPriceButton3');
	var globalPrice1Link = globalPrice1Container.getElementsByTagName('a')[0];
	var globalPrice2Link = globalPrice2Container.getElementsByTagName('a')[0];
	var globalPrice3Link = globalPrice3Container.getElementsByTagName('a')[0];

	if (item1Container && item2Container && item3Container && itemMoreContainer &&
		item1Link && item2Link && item3Link && itemMoreLink && itemLessLink &&
		globalPrice1Container && globalPrice2Container && globalPrice3Container &&
		globalPrice1Link && globalPrice2Link && globalPrice3Link) {
			if (larger) {
				selectedGroup++;
				if (selectedGroup+1 > groupsObject.groups.length) {
					return false;
				}
				itemLessLink.onclick = function() {
					return servicesSizes(false, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
				}
			} else {
				selectedGroup--;
				if (selectedGroup <= 0) {
					selectedGroup = 0;
					itemLessLink.onclick = function() {
						return servicesSizes(true, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
					}
				} else {
					itemLessLink.onclick = function() {
						return servicesSizes(false, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
					}
				}
			}
			itemMoreLink.onclick = function() {
				return servicesSizes(true, selectedGroup, item1Box, item2Box, item3Box, itemMoreBox);
		}
		var group = groupsObject.groups[selectedGroup];

		if (window.groupsObject.preserveDomainName) {
			item1Link.href = globalPrice1Link.href = group.size1.urlNotResetDomain;
			item2Link.href = globalPrice2Link.href = group.size2.urlNotResetDomain;
			item3Link.href = globalPrice3Link.href = group.size3.urlNotResetDomain;
		} else {
			item1Link.href = globalPrice1Link.href = group.size1.url;
			item2Link.href = globalPrice2Link.href = group.size2.url;
			item3Link.href = globalPrice3Link.href = group.size3.url;
		}
		item1Container.className = item2Container.className = item3Container.className = itemMoreContainer.className = globalPrice1Container.className = globalPrice2Container.className = globalPrice3Container.className = group.groupName;
	}
	return false;
}

function globalOnload() {
	// Set popups for target="_blank" links
	if (document.getElementById('products') || document.getElementById('prices') || document.getElementById('product_info')) {
		setLinkpopups();
	}
	// Set DHTML popup for relevant links
	if (document.getElementById('login') && document.getElementById('login').onmousedown != stopEvent) {
		initLogin();
	}

	// Set up webmail login form
	new WebmailEnhancer(document.getElementById('webmailLogin'));

	// Call specificOnload if defined
	if (window.specificOnload) {
		specificOnload();
	}
	applyServicesLargerSizesBehaviour();
}

/* Notice: Copied from Events.js */
var Events = {
	_events: [],
	_cleanup: [],

	attach: function(obj, type, func, thisObject) {
		var fn = thisObject ? function(e){func.call(thisObject, e);} : func;
		if (obj === window && type === 'unload') {
			this._cleanup[this._cleanup.length] = {
				obj: obj,
				type: type,
				fn: fn
			};
		} else {
			if (obj.addEventListener) {
				obj.addEventListener(type, fn, false);
			} else if(obj.attachEvent) {
				obj["e" + type + fn] = fn;
				obj[type + fn] = function() {
					var evt = window.event;
					evt.target = evt.srcElement;
					if (!BO.ie7 || obj["e" + type + fn]) {
						obj["e" + type + fn](evt);
					}
				};
				obj.attachEvent("on" + type, obj[type + fn]);
			}
			this._events[this._events.length] = {
				obj: obj,
				type: type,
				fn: fn
			};
		}
		return fn;
	},

	detach: function(obj, type, fn, cleanup) {
		if (obj === window && type === 'unload') {
			for (var i = 0; i < this._cleanup.length; i++) {
				if (this._cleanup[i].fn === fn) {
					this._cleanup.splice(i, 1);
					break;
				}
			}
		} else {
			if (obj.removeEventListener) {
				obj.removeEventListener(type, fn, false);
			} else if(obj.detachEvent) {
				obj.detachEvent("on" + type, obj[type + fn]);
				obj[type + fn] = null;
				obj["e" + type + fn] = null;
			}

			if (!cleanup) {
				for (var i = 0; i < this._events.length; i++) {
					if (this._events[i].obj === obj && this._events[i].type === type && this._events[i].fn === fn) {
						this._events.splice(i, 1);
						break;
					}
				}
			}
		}
	},

	cleanup: function(e) {
		var clean, evt;
		while (this._cleanup.length) {
			clean = this._cleanup.pop();
			clean.fn(e);
		}

		while (this._events.length) {
			evt = this._events.pop();
			this.detach(evt.obj, evt.type, evt.fn, true);
			evt = null;
		}
	},

	stopPropagation: function(e) {
		e = e || window.event;
		if (e) {
			e.cancelBubble = true;
			if (e.stopPropagation) {
				e.stopPropagation();
			}
		}
	},

	preventDefault: function(e) {
		e = e || window.event;
		if (e) {
			if (e.preventDefault) {
				e.preventDefault();
			}else{
				e.returnValue = false;
			}
		}
		return false;
	},

	stop: function(e) {
		e = e || window.event;
		Events.stopPropagation(e);
		return Events.preventDefault(e);
	}
};

window.onunload = function(e) {
	Events.cleanup(e);
};

function DemoPopup(demoButton) {
	this.demoButton = demoButton;
	this.popupOpen = false;
	this.applyOpenDemoPopupBehaviour();
}

DemoPopup.prototype = {
	toString : function(){return '[object DemoPopup]';},
	demoButton : null,
	popup : null,
	popupDemoContainer : null,
	iframe : null,
	overlay : null,
	popupOpen : null,

	applyOpenDemoPopupBehaviour : function() {
		this.popup = document.getElementById('demo-popup');
		this.popupDemoContainer = document.getElementById('demoMovie');
		if (this.popupDemoContainer) {
			if (this.demoButton) {
				Events.attach(this.demoButton,"click",function(e) {
					Events.stop(e);
					this.showDemoPopup();
				},this);
			}
		}
	},
	
	showDemoPopup : function() {
		if (this.popupOpen) {
			this.hideDemoPopup();
		}
		var flashElement = document.getElementById('flash');
		if (flashElement) {
			flashElement.style.visibility = 'hidden';
		}
		
		this.iframe = document.createElement('iframe');
		this.iframe.src = '//www.youtube.com/embed/4zdkoiqI5oM?rel=0&amp;hd=1';
		this.iframe.width = '853px';
		this.iframe.height = '510px';
		this.iframe.frameBorder = 0;
		
		this.popupDemoContainer.appendChild(this.iframe);
		
		//document.getElementById('content').appendChild(this.iframe);
		
		this.overlay = document.createElement('div');
		this.overlay.id = 'overlay';
		this.overlay.style.height = F.pos.getPageHeight() + 'px';
		document.getElementsByTagName('body')[0].appendChild(this.overlay);
		
		Events.attach(this.overlay,"click",function(){
			this.hideDemoPopup();
		},this);
		Events.attach(document.getElementById('demoPopupClose'),"click",function(){
			this.hideDemoPopup();
		},this);
		
		this.popup.style.top = F.pos.getScroll()+(F.pos.getClientViewportHeight()-this.popup.offsetHeight)/2+"px";
		
		this.popupOpen = true;
	},
		
	hideDemoPopup : function() {
		var flashElement = document.getElementById('flash');
		if (flashElement) {
			flashElement.style.visibility = 'visible';
		}
		this.overlay.parentNode.removeChild(this.overlay);
		this.popup.style.top = "-3000px";
		// Required to avoid wierd black box for IE8.
		this.iframe.src = '#';
		this.iframe.parentNode.removeChild(this.iframe);
		
		this.popupOpen = false;
	}
}

// Notice: Used by the flash movie.
function play_movie() {
	if (demoPopup) {
		demoPopup.showDemoPopup()
	}
}

Presentation.prototype = {
	toString : function(){return '[object Presentation]';},
	domref : null,
	// A reference to the element containg the flash movie.
	flashRef : null,
	// The height of the Presentation element during onload.
	initAreaHeight : null,
	// The current height of the Presentation element.
	presentHeight : null,
	// The max moving time - It shouldn't be possible to move the content in more thant five seconds.
	constMaxMovingTime : 5000,
	// The maximum result height - It shouldn't be possible to move the content more that to 600 px.
	constMaxResultHeight : 600,
	// The time delay between each move step.
	constMSPerStep : 50,
	// We need two different timers so the scripts can run at the same time
	moveTimer : null,
	// Whether or not flash is used. If not, the initAreaHeight should be the height of the replacement image.
	usingFlash : null,

	fadeSpeed : 10,
	fadeStep : 20,
	opacity : 0,
	maxOpacity : 40,
	timer : null,
	fader : null,

	// This is one of the methods that the flash action script can call -
	// Takes fewer arguments to minimize the room for error.
	moveUp : function(movingTime) {
		this.move(movingTime, this.initAreaHeight);
	},

	// Like the one above.
	moveDown : function (movingTime, resultHeight) {
		this.move(movingTime, resultHeight);
	},

	// This is the general move method - Called both directly and through moveDown and moveUp.
	move : function(movingTime, resultHeight, moveElement, doAfterRun) {
		// If the moveElement is not present, we assume that we are working on the flash area.
		if (!moveElement) {
			moveElement = this.flashRef;
			// The move animation used to extend the flash area works on a wrapper for the flash
			// object, the object tag is not resized until after the run - This is due to the
			// fact that it would be to hardware demanding to resize the flash object runtime.
			doAfterRun = function(moveElement) {
				if (moveElement.getElementsByTagName('object')[0]) {
					moveElement.getElementsByTagName('object')[0].style.height = moveElement.obj.presentHeight + 'px';
				}
			}
		}

		this.presentHeight = (!this.presentHeight) ? this.initAreaHeight : this.presentHeight;

		movingTime = (movingTime > this.constMaxMovingTime) ? this.constMaxMovingTime : movingTime;
		movingTime = (movingTime < 1) ? 1 : movingTime;
		resultHeight = (resultHeight < 0) ? 0 : resultHeight;
		resultHeight = (resultHeight > this.constMaxResultHeight) ? this.constMaxResultHeight : resultHeight;

		if (!moveElement) {
			return false;
		}
		moveElement.obj = this;

		// The distance which the element should be moved.
		moveDistance = resultHeight - this.presentHeight;

		// The number of steps the the move should be performed in.
		steps = Math.floor(movingTime / this.constMSPerStep);

		steps = (steps < 1) ? 1 : steps;

		absMoveDistance = Math.abs(moveDistance);
		// If the number of miliseconds it should take is too high for the move distance, we substract ten percent of the moving time until the move distance in pixel is equal to or higher than the number of steps.
		while (absMoveDistance / steps <= 1) {
			movingTime = movingTime - movingTime * 0.1;
			steps = Math.floor(movingTime / this.constMSPerStep);
		}

		restDistance = moveDistance % steps;

		// We need to divide with the numeric value of the move distance...
		distancePerStep = Math.floor(absMoveDistance / steps);

		// ...But the distance per step should still have to be the correct value according to the move distance.
		distancePerStep = (moveDistance < 0) ? distancePerStep * -1 : distancePerStep;
		var i = 0;

		var msPerStep = (movingTime < this.constMSPerStep) ? movingTime : this.constMSPerStep;
		var _this = this;
		window.clearInterval(this.moveTimer);
		this.moveTimer = window.setInterval(function(){
			if (i < steps) {
				// We need to either add or substract the rest distance, according to whether the distance is positive or negative.
				restConstant = (restDistance > 0) ? 1 : -1;
				if (restDistance != 0) {
					_this.presentHeight += distancePerStep;
					_this.presentHeight += restConstant;
					restDistance -= restConstant;
				} else {
					_this.presentHeight += distancePerStep;
				}
				moveElement.style.height = _this.presentHeight + 'px';
				i++;
			} else {
				window.clearInterval(_this.moveTimer);
				_this.updateFaderHeight();
				if (doAfterRun) {
					doAfterRun(moveElement);
				}
			}
		}, msPerStep);
	},

	makeFader : function() {
		this.fader = document.createElement('div');
		this.fader.style.position = 'absolute';
		this.fader.style.top = '0';
		this.fader.style.left = '0';
		this.fader.style.width = '100%';
		this.fader.style.zIndex = '9';
		this.fader.id = 'fader';

		this.fader.style.height = this.getWindowHeight() + 'px';
		this.fader.style.backgroundColor = '#000';
		this.updateFader();
		var _this = this;
		this.fader.onclick = function(){_this.fadeOut();};

		document.body.appendChild(this.fader);
	},

	getWindowHeight : function() {
		windowHeight = 100;

		pageHeight = document.body.scrollHeight > document.body.offsetHeight ? document.body.scrollHeight : document.body.offsetHeight;

		if (self.innerHeight) {
			windowHeight = self.innerHeight;
		}
		else if (document.documentElement && document.documentElement.scrollHeight) {
			windowHeight = document.documentElement.clientHeight;
		} else if (document.body) {
			windowHeight = document.body.clientHeight;
		}

		return windowHeight > pageHeight ? windowHeight : pageHeight;
	},

	updateFader : function() {
		this.fader.style.display = (this.opacity > 0) ? 'block' : 'none';
		this.fader.style.opacity = this.opacity / 100;
		this.fader.style.MozOpacity = this.opacity / 100;
		this.fader.style.filter = 'alpha(opacity=' + parseInt(this.opacity) + ')';
	},

	updateFaderHeight : function(){
		if(this.fader){
			this.fader.style.height = this.getWindowHeight() + 'px';
		}
	},

	fadeIn : function() {
		this.setIE6FadeProblemFixingSettings();
		if (!this.fader) this.makeFader();
		var _this = this;
		window.clearInterval(this.timer);
		this.timer = window.setInterval(function(){
			if (_this.opacity < _this.maxOpacity) {
				_this.opacity += _this.fadeStep;
				_this.updateFader();
			} else {
				window.clearInterval(_this.timer);
			}
		}, _this.fadeSpeed);
		window.onresize = function(){
			_this.updateFaderHeight();
		}
	},

	setIE6FadeProblemFixingSettings : function() {
		/*@cc_on
			/*@if (@_jscript_version == 5.6)
				document.getElementById('ie6_scroll_hack').style.overflowY = 'visible';
				document.getElementById('globalSearchBar').style.marginRight = '0px';
			/*@end
		@*/
	},
	resetIE6FadeProblemFixingSettings : function() {
		/*@cc_on
			/*@if (@_jscript_version == 5.6)
				document.getElementById('ie6_scroll_hack').style.overflowY = '';
				document.getElementById('globalSearchBar').style.marginRight = '';
			/*@end
		@*/
	},

	fadeOut : function() {
		this.resetIE6FadeProblemFixingSettings();
		var _this = this;
		window.clearInterval(this.timer);
		this.timer = window.setInterval(function(){
			if (_this.opacity > 0) {
				_this.opacity -= _this.fadeStep;
				_this.updateFader();
			} else {
				window.clearInterval(this.timer);
				window.onresize = null;
			}
		}, _this.fadeSpeed);
	}
}

function Presentation(objPresentation) {
	this.domref = objPresentation;
	this.domref.obj = this;
	this.usingFlash = usingFlash;
	this.initAreaHeight = (usingFlash) ? parseInt(flashHeight) : document.getElementById('flash').getElementsByTagName('img')[0].offsetHeight;
	this.presentHeight = this.initAreaHeight;
	this.flashRef = document.getElementById('flash');
}

// Due to the stupid eolas patent thing, we need to create the frontpage flash
// from an external script file to avoid forcing IE6+ users to click on the flash
// object to activate it.
function writeFrontpageFlash(height,flashUrl,gifUrl,bannerFullFlashDirUrl) {
	// It is really a bit stupid to declare global variables used by the Presentation Object
	// at this point. But we cannot make the presentation object output the flash as it needs
	// to be generated by document.write, and the presentation object cannot be initialized
	// until the html have been generated, while the flash should be generated inside the
	// presentation html element, which ofcourse is before the element is fully loaded.
	flashHeight = height;
	usingFlash = swfobject.hasFlashPlayerVersion('8');

	// Deactivate flash for android mobile.
	if (navigator && navigator.userAgent) {
		var uagent = navigator.userAgent.toLowerCase();
		if ((uagent.search('android')) > -1 && (uagent.search('webkit') > -1)) {
			usingFlash = false;
		}
	}

	if (usingFlash) {
		document.write('<object type="application/x-shockwave-flash" style="height: ' + height + 'px" data="' + flashUrl + '" />');
		document.write('<param name="movie" value="' + flashUrl + '" />');
		document.write('<param name="quality" value="high" />');
		document.write('<param name="salign" value="t" />');
		document.write('<param name="base" value="' + bannerFullFlashDirUrl + '" />');
		document.write('<param name="wmode" value="transparent" />');
		document.write('</object>');
	} else {
		document.write('<img src="' + gifUrl + '" alt="" />');
	}
}

/** The next two methods are all nessecary to make the search-animation work our supported
  * browsers. The animation works in IE6+, Opera, FF and Safari. IE5-5.5 fails in an acceptable
  * way. For all browsers (except IE6), the "search in progress" is hidden with visibility:hidden
  * and position:absoulte, which should provide the same behaviour as display:none. But because
  * Opera doesn't fetch images that has display:none, and doesn't fetch images after unload has begun,
  * we cannot use display:none. On the other hand, because of the way the search bar is positioned
  * in Internet Explorer 6, the browser cannot contain absolutely positioned elements, and therefore,
  * IE6 demands that the wrapper is hidden with display:none. The properties is reversed it the IE6
  * specific stylesheet.
  */
/** To force Internet Explorers to display the animation every time we need to refresh the source.
  */
function refreshSource(objHtmlImg) {
	if (objHtmlImg) {
		if (objHtmlImg.src) {
			objHtmlImg.src = objHtmlImg.src;
		}
	}
}
function generalWaitAnimation(waitMessageId) {
	var waitmessageWrapper = document.getElementById(waitMessageId);
	if (waitmessageWrapper) {
		waitmessageImage = waitmessageWrapper.getElementsByTagName("img")[0];
		if (waitmessageImage) {
			setTimeout('refreshSource(waitmessageImage)',0);
		}
		doupdate(waitMessageId, true);
	}
}

function openGuide(objHtmlLink) {
	window.open(objHtmlLink.href, "GUIDE", "width=758, height=552, top=0, menubar=no, status=no, location=no, toolbar=no, scrollbars=yes, resizable=no");
}
/* Standalone version of the onReady code from jQuery 1.2.2  */

function onReady(f) {
	// Attach the listeners
	onReady.bindReady();

	// If the DOM is already ready
	if (onReady.isReady) {
		// Execute the function immediately
		f.call(window);
		// Otherwise, remember the function for later
	}else{
		// Add the function to the wait list
		onReady.readyList.push(function() { return f.call(window);});
		return this;
	}
}

/* Notice: Copied from onReady.js */
onReady.isReady = false;
onReady.readyList = [];
onReady.ready = function() { // Handle when the DOM is ready
	// Make sure that the DOM is not already loaded
	if (!onReady.isReady) {
		// Remember that the DOM is ready
		onReady.isReady = true;

		// If there are functions bound, to execute
		if (onReady.readyList) {
			// Execute all of them
			for (var i=0 ; i<onReady.readyList.length ; i++) {
				onReady.readyList[i].call(window);
			}
			// Reset the list of functions
			onReady.readyList = null;
		}
	}
};

onReady.readyBound = false;

onReady.bindReady = function(){
	if (onReady.readyBound) {
		return;
	}
	onReady.readyBound = true;

	// Mozilla, Opera (see further below for it) and webkit nightlies currently support this event
	if (document.addEventListener && !BO.opera) {
		// Use the handy event callback
		document.addEventListener("DOMContentLoaded", onReady.ready, false);
	}

	// If IE is used and is not in a frame
	// Continually check to see if the document is ready
	if (BO.ie && window === top) {
		(function checkIfReadyIE(){
			if (onReady.isReady) {
				return;
			}
			try {
				// If IE is used, use the trick by Diego Perini
				// http://javascript.nwbox.com/IEContentLoaded/
				document.documentElement.doScroll("left");
			} catch(e) {
				setTimeout(checkIfReadyIE, 0);
				return;
			}
			// and execute any waiting functions
			onReady.ready();
		})();
	}

	if (BO.opera) {
		document.addEventListener("DOMContentLoaded", function checkIfReadyOpera() {
			if (onReady.isReady) {
				return;
			}
			for (var i = 0; i < document.styleSheets.length; i++) {
				if (document.styleSheets[i].disabled) {
					setTimeout(checkIfReadyOpera, 0);
					return;
				}
			}
			// and execute any waiting functions
			onReady.ready();
		}, false);
	}
	if (BO.safari) {
		var numStyles;
		(function checkIfReadySafari(){
			if (onReady.isReady) {
				return;
			}
			if (document.readyState !== "loaded" && document.readyState !== "complete") {
				setTimeout(checkIfReadySafari, 0);
				return;
			}
			if (numStyles === undefined) {
				numStyles = document.getElementsByTagName('style').length;
				var links = document.getElementsByTagName('link');
				for (var i=0 ; i<links.length ; i++) {
					if (/stylesheet/i.test(links[i].rel)) {
						numStyles++;
					}
				}
			}

			if (document.styleSheets.length !== numStyles) {
				setTimeout(checkIfReadySafari, 0);
				return;
			}
			// and execute any waiting functions
			onReady.ready();
		})();
	}

	// A fallback to window.onload, that will always work
	if (window.addEventListener) {
		window.addEventListener('load', onReady.ready, false);
	}else if(window.attachEvent) {
		window.attachEvent("onload", onReady.ready);
	}else{
		var oldonload = window.onload;
		window.onload = function() {
			if (oldonload) {
				oldonload.call(window);
			}
			onReady.ready();
		};
	}
};

onReady(function(){
	// Frame buster
	if (top!= self) {
		top.location.replace(self.location.href);
	}

	var demoButton = document.getElementById('demoButton');
	if (demoButton) {
		demoPopup = new DemoPopup(demoButton);
	}

	var presentation = document.getElementById('presentation');
	if (presentation) {
		pres = new Presentation(presentation);
	}
	
	var container = document.getElementById('template_global_search');
	if (container) {
		var select = container.getElementsByTagName('select')[0];
		if (select) {
			Dropdown.fromSelect(select);
		}
	}
	var container = document.getElementById('frontpage_global_search');
	if (container) {
		var select = container.getElementsByTagName('select')[0];
		if (select) {
			Dropdown.fromSelect(select);
		}
	}
	var container = document.getElementById('center_search');
	if (container) {
		var select = container.getElementsByTagName('select')[0];
		if (select) {
			Dropdown.fromSelect(select);
		}
		if (document.getElementById('choose_domain_form_domain')) {
			var input = container.getElementsByTagName('input')[0];
			if (input) {
				var value = input.value;
				Events.attach(input, 'click', function(e) {
					clearInput(input);
				});
				Events.attach(input, 'keydown', function(e) {
					clearInput(input);
				});
				Events.attach(input.form, 'submit', function(e) {
					if (input.value == value) {
						clearInput(input);
					}
				});
			}
		}
	}
	globalOnload();
});

function clearInput(input) {
	if (M.dom.hasClass(input, 'unmodified')) {
		M.dom.removeClass(input, 'unmodified');
		input.value = '';
	}
}

function applyExtraInfoTipBehaviour() {
	var servicesContainer = document.getElementById('services');
	if (servicesContainer) {
		var divs = servicesContainer.getElementsByTagName('div');
		Events.attach(servicesContainer, 'click', function(e) {
			var target = e.target || event.srcElement;
			if (target.href) {
				return;
			} else {
				while (target.className != 'infoRow' && target.id != 'services') {
					target = target.parentNode;
				}
				if (target.className == 'infoRow') {
					window.location = target.getElementsByTagName('a')[0].href;
				}
			}
		});
		for (var i = 0 ; i < divs.length ; i++) {
			if (divs[i].className == 'infoRow') {
				// TODO: Stupid IE6 hack.
				if (!divs[i].id == 'infoLast' || !(BO.ie6 && divs[i].id == 'infoLast')) {
					Events.attach(divs[i], 'mouseover', function() {
						var innerDivs = this.getElementsByTagName('div');
						for (var i = 0 ; i < innerDivs.length ; i++) {
							if (innerDivs[i].className == 'extraInfoTip') {
								innerDivs[i].style.display = 'block';
							}
							else if (innerDivs[i].className == 'notHover') {
								innerDivs[i].className = 'hover';
							}
						}
					});
					Events.attach(divs[i], 'mouseout', function() {
						var innerDivs = this.getElementsByTagName('div');
						for (var i = 0 ; i < innerDivs.length ; i++) {
							if (innerDivs[i].className == 'extraInfoTip') {
								innerDivs[i].style.display = 'none';
							}
							else if (innerDivs[i].className == 'hover') {
								innerDivs[i].className = 'notHover';
							}
						}
					});
				}
			}
		}
	}
	var priceHeader = document.getElementById('price_header');
	if (priceHeader) {
		Events.attach(priceHeader, 'mouseover', function() {
			priceHeader.className = 'hover';
		});
		Events.attach(priceHeader, 'mouseout', function() {
			priceHeader.className = 'notHover';
		});
		Events.attach(priceHeader, 'click', function(e) {
			var target = e.target || event.srcElement;
			if (target.href) {
				return;
			} else {
				while (target.id != 'price_header') {
					target = target.parentNode;
				}
				window.location = target.getElementsByTagName('a')[0].href;
			}
		});
	}
}

function insertAjaxLoader(objHtmlElement) {
	var loader = document.createElement('div');
	loader.className = 'loader';
	loader.style.height = objHtmlElement.offsetHeight + 'px';
	loader.style.width = objHtmlElement.offsetWidth + 'px';
	objHtmlElement.insertBefore(loader, objHtmlElement.firstChild);
	return loader;
}

/* Notice: Copied from DHTMLPOPUP.js */
function DHTMLPopup(popupId){
	this.popup = document.createElement("div");
	var frame = document.createElement("div");
	this.inner = document.createElement("div");
	var closer = document.createElement("a");
	closer.appendChild(document.createTextNode("X"));
	this.popup.className = "dhtml-popup";
	if (popupId) {
		this.popup.id = popupId;
	}
	frame.className = "frame";
	this.inner.className = "inner";
	closer.className = "closer";
	frame.appendChild(closer);
	frame.appendChild(this.inner);
	this.popup.appendChild(frame);
	document.body.appendChild(this.popup);
	Events.attach(closer,"click",function(){
		this.hide();},this);
	Events.attach(document,"keyup",function(e){
		e = e || window.event;
		if (e && e.keyCode == 27) {
			this.hide();
		}
	},this);
}

DHTMLPopup.prototype = {
	toString : function(){return '[object DHTMLPopup]';},
	show : function(top){
		this.popup.style.top = top + "px";
		Events.attach(document,"mousedown",function(){
			this.hide();
		},this);
		Events.attach(this.popup,"mousedown",function(e){
			Events.stopPropagation(e);
		});
	},
	hide : function(){
		this.popup.style.top = "-3000px";
	},
	loadContent : function(HTMLObject){
		this.inner.innerHTML = HTMLObject.innerHTML;
	},
	getInner : function(){
		return this.inner;
	},
	clear : function(){
		this.inner.innerHTML = "";
	},
	topHeight : function(height){
		this.popup.style.top = F.pos.getScroll()+(F.pos.getClientViewportHeight()-height)/2+"px";
	},
	top : function(){
		this.popup.style.top = F.pos.getScroll()+(F.pos.getClientViewportHeight()-this.popup.offsetHeight)/2+"px";
	},
	insertAjaxLoader : function() {
		this.loader = document.createElement('div');
		this.loader.className = 'loader';
		this.loader.style.height = this.inner.offsetHeight + 'px';
		this.loader.style.width = this.inner.offsetWidth + 'px';
		this.inner.appendChild(this.loader);
	},
	removeAjaxLoader : function() {
		if (this.loader) {
			this.loader.parentNode.removeChild(this.loader);
		}
	}
}

/* Notice: Copied from F.js */
var F = {
	dom : {
		cleanWhiteSpace : function(objHTMLElement) {
			var childNode;
			var notWhitespace = /\S/;
			for (var x = 0; x < objHTMLElement.childNodes.length; x++) {
				childNode = objHTMLElement.childNodes[x];
				if ((childNode.nodeType == 3)&&(!notWhitespace.test(childNode.nodeValue))) {
					objHTMLElement.removeChild(objHTMLElement.childNodes[x--]);
				}
				if (childNode.nodeType == 1) {
					this.cleanWhiteSpace(childNode);
				}
			}
		}
	},
	pos : {
		getMousePos : function(e){
			var posx = 0;
			var posy = 0;
			var e = e || window.event;
			if (e.pageX || e.pageY) 	{
				posx = e.pageX;
				posy = e.pageY;
			}
			else if (e.clientX || e.clientY) 	{
				posx = e.clientX + document.body.scrollLeft
					+ document.documentElement.scrollLeft;
				posy = e.clientY + document.body.scrollTop
					+ document.documentElement.scrollTop;
			}
			return new Array(posx,posy);
		},
		getObjectPos : function(obj) {
			var curleft = curtop = 0;
			if (obj.offsetParent) {
				curleft = obj.offsetLeft
				curtop = obj.offsetTop
				while (obj = obj.offsetParent) {
					curleft += obj.offsetLeft
					curtop += obj.offsetTop
				}
			}
			return [curleft,curtop];
		},
		getScrollOffset : function(){
			var y,h;
			if (self.pageYOffset) // all except Explorer
			{
				y = self.pageYOffset;
				h = self.innerHeight;
			}
			else if (document.documentElement && document.documentElement.scrollTop)
				// Explorer 6 Strict
			{
				y = document.documentElement.scrollTop;
				h = document.documentElement.clientHeight;
			}
			else if (document.body) // all other Explorers
			{
				y = document.body.scrollTop;
				h = document.body.clientHeight;
			}
			return y+200;

		},
		getScroll : function(){
			var y,h;
			if (self.pageYOffset) // all except Explorer
			{
				y = self.pageYOffset;
				h = self.innerHeight;
			}
			else if (document.documentElement && document.documentElement.scrollTop)
				// Explorer 6 Strict
			{
				y = document.documentElement.scrollTop;
				h = document.documentElement.clientHeight;
			}
			else if (document.body) // all other Explorers
			{
				y = document.body.scrollTop;
				h = document.body.clientHeight;
			}
			return y;

		},
		getClientViewportHeight : function() {
			var height;
			// all except Explorer
			if (self.innerHeight) {
				height = self.innerHeight;
			}
			// Explorer 6 Strict
			else if (document.documentElement && document.documentElement.clientHeight) {
				height = document.documentElement.clientHeight;
			}
			// all other Explorers
			else if (document.body) {
				height = document.body.clientHeight;
			}
			return height;
		},
		getPageHeight : function() {
			var pageHeight = document.body.scrollHeight > document.body.offsetHeight ? document.body.scrollHeight : document.body.offsetHeight;
			return F.pos.getClientViewportHeight() > pageHeight ? F.pos.getClientViewportHeight() : pageHeight;
		}
	},
	sel : {
		id : function(id){
			return document.getElementById(id);
		},
		firstClass : function(selector, container){
			var m = selector.match("^(?:([^.]+)\.)?(.+)$");
			var tag = m[1] || '*',
			re = new RegExp("\\b" + m[2] + "\\b");
			container = (container) ? container : document;
			var nodeList = container.getElementsByTagName(tag);
			for(var i = nodeList.length - 1; i >= 0; i--){
				if ( re.test(nodeList[i].className)) {
					return nodeList[i];
				}
			}
		},
		forTag : function(tag,fn,thisObject,inOrder){
			var nodeList = document.getElementsByTagName(tag);
			if(inOrder){
				F.sel.nodeList2Array(nodeList).forEach(function(n){
					fn.call(thisObject,n);
				});
			}
			else{
				for(var i = nodeList.length - 1; i >= 0; i--){
					fn.call(thisObject,nodeList[i]);
				}
			}
		},
		forClass : function(selector,fn,thisObject,inOrder){
			var m = selector.match("^(?:([^.]+)\.)?(.+)$");
			var tag = m[1] || '*',
			re = new RegExp("\\b" + m[2] + "\\b");

			F.sel.forTag(tag,function(e) {
				if (e.className && re.test(e.className)) {
					fn.call(thisObject, e);
				}
			}, null, inOrder);

		},
		nodeList2Array : function(nodeList){
			var a = [];
			for(var i = 0; i < nodeList.length; i++){
				a.push(nodeList[i]);
			}
			return a;
		}
	}
}

/* Notice: Copied from swfobject.js */
/*	SWFObject v2.2 <http://code.google.com/p/swfobject/>
	is released under the MIT License <http://www.opensource.org/licenses/mit-license.php>
*/
var swfobject=function(){var D="undefined",r="object",S="Shockwave Flash",W="ShockwaveFlash.ShockwaveFlash",q="application/x-shockwave-flash",R="SWFObjectExprInst",x="onreadystatechange",O=window,j=document,t=navigator,T=false,U=[h],o=[],N=[],I=[],l,Q,E,B,J=false,a=false,n,G,m=true,M=function(){var aa=typeof j.getElementById!=D&&typeof j.getElementsByTagName!=D&&typeof j.createElement!=D,ah=t.userAgent.toLowerCase(),Y=t.platform.toLowerCase(),ae=Y?/win/.test(Y):/win/.test(ah),ac=Y?/mac/.test(Y):/mac/.test(ah),af=/webkit/.test(ah)?parseFloat(ah.replace(/^.*webkit\/(\d+(\.\d+)?).*$/,"$1")):false,X=!+"\v1",ag=[0,0,0],ab=null;if(typeof t.plugins!=D&&typeof t.plugins[S]==r){ab=t.plugins[S].description;if(ab&&!(typeof t.mimeTypes!=D&&t.mimeTypes[q]&&!t.mimeTypes[q].enabledPlugin)){T=true;X=false;ab=ab.replace(/^.*\s+(\S+\s+\S+$)/,"$1");ag[0]=parseInt(ab.replace(/^(.*)\..*$/,"$1"),10);ag[1]=parseInt(ab.replace(/^.*\.(.*)\s.*$/,"$1"),10);ag[2]=/[a-zA-Z]/.test(ab)?parseInt(ab.replace(/^.*[a-zA-Z]+(.*)$/,"$1"),10):0}}else{if(typeof O.ActiveXObject!=D){try{var ad=new ActiveXObject(W);if(ad){ab=ad.GetVariable("$version");if(ab){X=true;ab=ab.split(" ")[1].split(",");ag=[parseInt(ab[0],10),parseInt(ab[1],10),parseInt(ab[2],10)]}}}catch(Z){}}}return{w3:aa,pv:ag,wk:af,ie:X,win:ae,mac:ac}}(),k=function(){if(!M.w3){return}if((typeof j.readyState!=D&&j.readyState=="complete")||(typeof j.readyState==D&&(j.getElementsByTagName("body")[0]||j.body))){f()}if(!J){if(typeof j.addEventListener!=D){j.addEventListener("DOMContentLoaded",f,false)}if(M.ie&&M.win){j.attachEvent(x,function(){if(j.readyState=="complete"){j.detachEvent(x,arguments.callee);f()}});if(O==top){(function(){if(J){return}try{j.documentElement.doScroll("left")}catch(X){setTimeout(arguments.callee,0);return}f()})()}}if(M.wk){(function(){if(J){return}if(!/loaded|complete/.test(j.readyState)){setTimeout(arguments.callee,0);return}f()})()}s(f)}}();function f(){if(J){return}try{var Z=j.getElementsByTagName("body")[0].appendChild(C("span"));Z.parentNode.removeChild(Z)}catch(aa){return}J=true;var X=U.length;for(var Y=0;Y<X;Y++){U[Y]()}}function K(X){if(J){X()}else{U[U.length]=X}}function s(Y){if(typeof O.addEventListener!=D){O.addEventListener("load",Y,false)}else{if(typeof j.addEventListener!=D){j.addEventListener("load",Y,false)}else{if(typeof O.attachEvent!=D){i(O,"onload",Y)}else{if(typeof O.onload=="function"){var X=O.onload;O.onload=function(){X();Y()}}else{O.onload=Y}}}}}function h(){if(T){V()}else{H()}}function V(){var X=j.getElementsByTagName("body")[0];var aa=C(r);aa.setAttribute("type",q);var Z=X.appendChild(aa);if(Z){var Y=0;(function(){if(typeof Z.GetVariable!=D){var ab=Z.GetVariable("$version");if(ab){ab=ab.split(" ")[1].split(",");M.pv=[parseInt(ab[0],10),parseInt(ab[1],10),parseInt(ab[2],10)]}}else{if(Y<10){Y++;setTimeout(arguments.callee,10);return}}X.removeChild(aa);Z=null;H()})()}else{H()}}function H(){var ag=o.length;if(ag>0){for(var af=0;af<ag;af++){var Y=o[af].id;var ab=o[af].callbackFn;var aa={success:false,id:Y};if(M.pv[0]>0){var ae=c(Y);if(ae){if(F(o[af].swfVersion)&&!(M.wk&&M.wk<312)){w(Y,true);if(ab){aa.success=true;aa.ref=z(Y);ab(aa)}}else{if(o[af].expressInstall&&A()){var ai={};ai.data=o[af].expressInstall;ai.width=ae.getAttribute("width")||"0";ai.height=ae.getAttribute("height")||"0";if(ae.getAttribute("class")){ai.styleclass=ae.getAttribute("class")}if(ae.getAttribute("align")){ai.align=ae.getAttribute("align")}var ah={};var X=ae.getElementsByTagName("param");var ac=X.length;for(var ad=0;ad<ac;ad++){if(X[ad].getAttribute("name").toLowerCase()!="movie"){ah[X[ad].getAttribute("name")]=X[ad].getAttribute("value")}}P(ai,ah,Y,ab)}else{p(ae);if(ab){ab(aa)}}}}}else{w(Y,true);if(ab){var Z=z(Y);if(Z&&typeof Z.SetVariable!=D){aa.success=true;aa.ref=Z}ab(aa)}}}}}function z(aa){var X=null;var Y=c(aa);if(Y&&Y.nodeName=="OBJECT"){if(typeof Y.SetVariable!=D){X=Y}else{var Z=Y.getElementsByTagName(r)[0];if(Z){X=Z}}}return X}function A(){return !a&&F("6.0.65")&&(M.win||M.mac)&&!(M.wk&&M.wk<312)}function P(aa,ab,X,Z){a=true;E=Z||null;B={success:false,id:X};var ae=c(X);if(ae){if(ae.nodeName=="OBJECT"){l=g(ae);Q=null}else{l=ae;Q=X}aa.id=R;if(typeof aa.width==D||(!/%$/.test(aa.width)&&parseInt(aa.width,10)<310)){aa.width="310"}if(typeof aa.height==D||(!/%$/.test(aa.height)&&parseInt(aa.height,10)<137)){aa.height="137"}j.title=j.title.slice(0,47)+" - Flash Player Installation";var ad=M.ie&&M.win?"ActiveX":"PlugIn",ac="MMredirectURL="+O.location.toString().replace(/&/g,"%26")+"&MMplayerType="+ad+"&MMdoctitle="+j.title;if(typeof ab.flashvars!=D){ab.flashvars+="&"+ac}else{ab.flashvars=ac}if(M.ie&&M.win&&ae.readyState!=4){var Y=C("div");X+="SWFObjectNew";Y.setAttribute("id",X);ae.parentNode.insertBefore(Y,ae);ae.style.display="none";(function(){if(ae.readyState==4){ae.parentNode.removeChild(ae)}else{setTimeout(arguments.callee,10)}})()}u(aa,ab,X)}}function p(Y){if(M.ie&&M.win&&Y.readyState!=4){var X=C("div");Y.parentNode.insertBefore(X,Y);X.parentNode.replaceChild(g(Y),X);Y.style.display="none";(function(){if(Y.readyState==4){Y.parentNode.removeChild(Y)}else{setTimeout(arguments.callee,10)}})()}else{Y.parentNode.replaceChild(g(Y),Y)}}function g(ab){var aa=C("div");if(M.win&&M.ie){aa.innerHTML=ab.innerHTML}else{var Y=ab.getElementsByTagName(r)[0];if(Y){var ad=Y.childNodes;if(ad){var X=ad.length;for(var Z=0;Z<X;Z++){if(!(ad[Z].nodeType==1&&ad[Z].nodeName=="PARAM")&&!(ad[Z].nodeType==8)){aa.appendChild(ad[Z].cloneNode(true))}}}}}return aa}function u(ai,ag,Y){var X,aa=c(Y);if(M.wk&&M.wk<312){return X}if(aa){if(typeof ai.id==D){ai.id=Y}if(M.ie&&M.win){var ah="";for(var ae in ai){if(ai[ae]!=Object.prototype[ae]){if(ae.toLowerCase()=="data"){ag.movie=ai[ae]}else{if(ae.toLowerCase()=="styleclass"){ah+=' class="'+ai[ae]+'"'}else{if(ae.toLowerCase()!="classid"){ah+=" "+ae+'="'+ai[ae]+'"'}}}}}var af="";for(var ad in ag){if(ag[ad]!=Object.prototype[ad]){af+='<param name="'+ad+'" value="'+ag[ad]+'" />'}}aa.outerHTML='<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000"'+ah+">"+af+"</object>";N[N.length]=ai.id;X=c(ai.id)}else{var Z=C(r);Z.setAttribute("type",q);for(var ac in ai){if(ai[ac]!=Object.prototype[ac]){if(ac.toLowerCase()=="styleclass"){Z.setAttribute("class",ai[ac])}else{if(ac.toLowerCase()!="classid"){Z.setAttribute(ac,ai[ac])}}}}for(var ab in ag){if(ag[ab]!=Object.prototype[ab]&&ab.toLowerCase()!="movie"){e(Z,ab,ag[ab])}}aa.parentNode.replaceChild(Z,aa);X=Z}}return X}function e(Z,X,Y){var aa=C("param");aa.setAttribute("name",X);aa.setAttribute("value",Y);Z.appendChild(aa)}function y(Y){var X=c(Y);if(X&&X.nodeName=="OBJECT"){if(M.ie&&M.win){X.style.display="none";(function(){if(X.readyState==4){b(Y)}else{setTimeout(arguments.callee,10)}})()}else{X.parentNode.removeChild(X)}}}function b(Z){var Y=c(Z);if(Y){for(var X in Y){if(typeof Y[X]=="function"){Y[X]=null}}Y.parentNode.removeChild(Y)}}function c(Z){var X=null;try{X=j.getElementById(Z)}catch(Y){}return X}function C(X){return j.createElement(X)}function i(Z,X,Y){Z.attachEvent(X,Y);I[I.length]=[Z,X,Y]}function F(Z){var Y=M.pv,X=Z.split(".");X[0]=parseInt(X[0],10);X[1]=parseInt(X[1],10)||0;X[2]=parseInt(X[2],10)||0;return(Y[0]>X[0]||(Y[0]==X[0]&&Y[1]>X[1])||(Y[0]==X[0]&&Y[1]==X[1]&&Y[2]>=X[2]))?true:false}function v(ac,Y,ad,ab){if(M.ie&&M.mac){return}var aa=j.getElementsByTagName("head")[0];if(!aa){return}var X=(ad&&typeof ad=="string")?ad:"screen";if(ab){n=null;G=null}if(!n||G!=X){var Z=C("style");Z.setAttribute("type","text/css");Z.setAttribute("media",X);n=aa.appendChild(Z);if(M.ie&&M.win&&typeof j.styleSheets!=D&&j.styleSheets.length>0){n=j.styleSheets[j.styleSheets.length-1]}G=X}if(M.ie&&M.win){if(n&&typeof n.addRule==r){n.addRule(ac,Y)}}else{if(n&&typeof j.createTextNode!=D){n.appendChild(j.createTextNode(ac+" {"+Y+"}"))}}}function w(Z,X){if(!m){return}var Y=X?"visible":"hidden";if(J&&c(Z)){c(Z).style.visibility=Y}else{v("#"+Z,"visibility:"+Y)}}function L(Y){var Z=/[\\\"<>\.;]/;var X=Z.exec(Y)!=null;return X&&typeof encodeURIComponent!=D?encodeURIComponent(Y):Y}var d=function(){if(M.ie&&M.win){window.attachEvent("onunload",function(){var ac=I.length;for(var ab=0;ab<ac;ab++){I[ab][0].detachEvent(I[ab][1],I[ab][2])}var Z=N.length;for(var aa=0;aa<Z;aa++){y(N[aa])}for(var Y in M){M[Y]=null}M=null;for(var X in swfobject){swfobject[X]=null}swfobject=null})}}();return{registerObject:function(ab,X,aa,Z){if(M.w3&&ab&&X){var Y={};Y.id=ab;Y.swfVersion=X;Y.expressInstall=aa;Y.callbackFn=Z;o[o.length]=Y;w(ab,false)}else{if(Z){Z({success:false,id:ab})}}},getObjectById:function(X){if(M.w3){return z(X)}},embedSWF:function(ab,ah,ae,ag,Y,aa,Z,ad,af,ac){var X={success:false,id:ah};if(M.w3&&!(M.wk&&M.wk<312)&&ab&&ah&&ae&&ag&&Y){w(ah,false);K(function(){ae+="";ag+="";var aj={};if(af&&typeof af===r){for(var al in af){aj[al]=af[al]}}aj.data=ab;aj.width=ae;aj.height=ag;var am={};if(ad&&typeof ad===r){for(var ak in ad){am[ak]=ad[ak]}}if(Z&&typeof Z===r){for(var ai in Z){if(typeof am.flashvars!=D){am.flashvars+="&"+ai+"="+Z[ai]}else{am.flashvars=ai+"="+Z[ai]}}}if(F(Y)){var an=u(aj,am,ah);if(aj.id==ah){w(ah,true)}X.success=true;X.ref=an}else{if(aa&&A()){aj.data=aa;P(aj,am,ah,ac);return}else{w(ah,true)}}if(ac){ac(X)}})}else{if(ac){ac(X)}}},switchOffAutoHideShow:function(){m=false},ua:M,getFlashPlayerVersion:function(){return{major:M.pv[0],minor:M.pv[1],release:M.pv[2]}},hasFlashPlayerVersion:F,createSWF:function(Z,Y,X){if(M.w3){return u(Z,Y,X)}else{return undefined}},showExpressInstall:function(Z,aa,X,Y){if(M.w3&&A()){P(Z,aa,X,Y)}},removeSWF:function(X){if(M.w3){y(X)}},createCSS:function(aa,Z,Y,X){if(M.w3){v(aa,Z,Y,X)}},addDomLoadEvent:K,addLoadEvent:s,getQueryParamValue:function(aa){var Z=j.location.search||j.location.hash;if(Z){if(/\?/.test(Z)){Z=Z.split("?")[1]}if(aa==null){return L(Z)}var Y=Z.split("&");for(var X=0;X<Y.length;X++){if(Y[X].substring(0,Y[X].indexOf("="))==aa){return L(Y[X].substring((Y[X].indexOf("=")+1)))}}}return""},expressInstallCallback:function(){if(a){var X=c(R);if(X&&l){X.parentNode.replaceChild(l,X);if(Q){w(Q,true);if(M.ie&&M.win){l.style.display="block"}}if(E){E(B)}}a=false}}}}();

/* Notice: Copied from M.js */
var M = {
	dom : {
		addClass : function(objHTMLElement, strClassName) {
			objHTMLElement.className += ' ' + strClassName;
		},
		
		removeClass : function(objHTMLElement, strClassName) {
			if (strClassName) {
				objHTMLElement.className = objHTMLElement.className.replace(new RegExp("\\b" + strClassName + "\\b", 'g'), ' ');
			}
		},
		
		hasClass : function(objHTMLElement, strClassName) {
			return new RegExp("\\b" + strClassName + "\\b").test(objHTMLElement.className);
		},

		toggleClass : function(objHTMLElement, strClassName) { /* returns true if the class was removed, false if it was added */
			var hadClass = M.dom.hasClass(objHTMLElement, strClassName);
			if (hadClass) {
				M.dom.removeClass(objHTMLElement, strClassName);
			}else{
				M.dom.addClass(objHTMLElement, strClassName);
			}
			return hadClass;
		},

		getStyle : function(objHTMLElement, style) {
			var value = "";

			style = style.replace(/([A-Z])/g, function(str, chr) { /* fromCamelCase */
				return "-" + chr.toLowerCase();
			});

			var ccStyle = style.replace(/-([a-z])/g, function(str, chr) { /* toCamelCase */
				return chr.toUpperCase();
			});

			if(value = objHTMLElement.style[ccStyle]) {
				return value;
			}

			var computedStyle = document.defaultView && document.defaultView.getComputedStyle && document.defaultView.getComputedStyle(objHTMLElement, "");
			if(computedStyle) {
				return computedStyle.getPropertyValue(style);
			} else if(objHTMLElement.currentStyle) {
				return objHTMLElement.currentStyle[ccStyle];
			}
			return value;
		},

		getOffset : function(obj, dir) {
			var offset = 0;
			do {
				offset += parseInt(obj[dir], 10);
			}while(obj = obj.offsetParent);
			return offset;
		},
		
		getRealOffset : function(obj) {
			var left = 0;
			var top = 0;
			var elem = obj;
			var results;
				
			if ( elem ) {
				var parent       = elem.parentNode, 
					offsetChild  = elem,
					offsetParent = elem.offsetParent, 
					doc          = elem.ownerDocument,
					version      = (navigator.userAgent.toLowerCase().match( /.+(?:rv|it|ra|ie)[\/: ]([\d.]+)/ ) || [])[1],
					safari2      = BO.safari && parseInt(version) < 522 && !/adobeair/i.test(userAgent),
					fixed        = M.dom.getStyle(elem, "position") == "fixed";
			
				// Use getBoundingClientRect if available
				if ( elem.getBoundingClientRect ) {
					var box = elem.getBoundingClientRect();
				
					// Add the document scroll offsets
					add(box.left + Math.max(doc.documentElement.scrollLeft, doc.body.scrollLeft),
						box.top  + Math.max(doc.documentElement.scrollTop,  doc.body.scrollTop));
				
					// IE adds the HTML element's border, by default it is medium which is 2px
					// IE 6 and 7 quirks mode the border width is overwritable by the following css html { border: 0; }
					// IE 7 standards mode, the border is always 2px
					// This border/offset is typically represented by the clientLeft and clientTop properties
					// However, in IE6 and 7 quirks mode the clientLeft and clientTop properties are not updated when overwriting it via CSS
					// Therefore this method will be off by 2px in IE while in quirksmode
					add( -doc.documentElement.clientLeft, -doc.documentElement.clientTop );
			
				// Otherwise loop through the offsetParents and parentNodes
				} else {
				
					// Initial element offsets
					add( elem.offsetLeft, elem.offsetTop );
					
					// Get parent offsets
					while ( offsetParent ) {
						// Add offsetParent offsets
						add( offsetParent.offsetLeft, offsetParent.offsetTop );
					
						// Mozilla and Safari > 2 does not include the border on offset parents
						// However Mozilla adds the border for table or table cells
						if ( BO.gecko && !/^t(able|d|h)$/i.test(offsetParent.tagName) || BO.safari && !safari2 )
							border( offsetParent );
							
						// Add the document scroll offsets if position is fixed on any offsetParent
						if ( !fixed && M.dom.getStyle(offsetParent, "position") == "fixed" )
							fixed = true;
					
						// Set offsetChild to previous offsetParent unless it is the body element
						offsetChild  = /^body$/i.test(offsetParent.tagName) ? offsetChild : offsetParent;
						// Get next offsetParent
						offsetParent = offsetParent.offsetParent;
					}
				
					// Get parent scroll offsets
					while ( parent && parent.tagName && !/^body|html$/i.test(parent.tagName) ) {
						// Remove parent scroll UNLESS that parent is inline or a table to work around Opera inline/table scrollLeft/Top bug
						if ( !/^inline|table.*$/i.test(M.dom.getStyle(parent, "display")) )
							// Subtract parent scroll offsets
							add( -parent.scrollLeft, -parent.scrollTop );
					
						// Mozilla does not add the border for a parent that has overflow != visible
						if ( BO.gecko && M.dom.getStyle(parent, "overflow") != "visible" )
							border( parent );
					
						// Get next parent
						parent = parent.parentNode;
					}
				
					// Safari <= 2 doubles body offsets with a fixed position element/offsetParent or absolutely positioned offsetChild
					// Mozilla doubles body offsets with a non-absolutely positioned offsetChild
					if ( (safari2 && (fixed || M.dom.getStyle(offsetChild, "position") == "absolute")) || 
						(BO.gecko && M.dom.getStyle(offsetChild, "position") != "absolute") )
							add( -doc.body.offsetLeft, -doc.body.offsetTop );
					
					// Add the document scroll offsets if position is fixed
					if ( fixed )
						add(Math.max(doc.documentElement.scrollLeft, doc.body.scrollLeft),
							Math.max(doc.documentElement.scrollTop,  doc.body.scrollTop));
				}
			
				// Return an object with top and left properties
				results = { top: top, left: left };
			}
			
			function border(elem) {
				add( parseInt(M.dom.getStyle(elem, "border-left-width")), parseInt(M.dom.getStyle(elem, "border-left-width")) );
			}
			
			function add(l, t) {
				left += parseInt(l) || 0;
				top += parseInt(t) || 0;
			}
			
			return results;
		}
	},

	obj : {
		extend : function(dest, src) {
			for (var p in src) {
				if (src.hasOwnProperty(p)) {
					dest[p] = src[p];
				}
			}
			return dest;
		},

		clone : function(obj) {
			return M.obj.extend({}, obj);
		},
		
		isArray : function(obj) {
			return Object.prototype.toString.apply(obj) === '[object Array]';
		}
	},

	fn : {
		fixScope : function(thisObject, lambda) {
			return function(/*...*/) {
				return lambda.apply(thisObject, arguments);
			};
		}
	},

	oo : {
		inherit : function(child, parent) {
			for (var property in parent.prototype) {
				child.prototype[property] = parent.prototype[property];
			}
		}
	},

	postObj : function(obj, postAction, postTarget) {
		var input; // Current newly created input Element
		var form = document.createElement('form');
		
		function makeInput(inputName, inputValue) {
			if (BO.ie) {
				input = document.createElement('<input name="'+inputName+'">');
			} else {
				input = document.createElement('input');
				input.name = inputName;
			}
			input.type = 'hidden';
			input.value = inputValue;
			return input;
		}
		
		form.method = 'post';
		form.action = postAction || document.location.href;
		form.target = postTarget || '_self';
		for (var property in obj) {
			if (obj.hasOwnProperty(property)) {
				var value = obj[property];
				/* Array detection using "the Miller Device" documented here:
				 * http://blog.360.yahoo.com/blog-TBPekxc1dLNy5DOloPfzVvFIVOWMB0li?p=916 */
				if (Object.prototype.toString.apply(value) === '[object Array]') {
					for (var i = 0; i < value.length; i++) {
						form.appendChild(makeInput(property, value[i]));
					}
				} else {
					form.appendChild(makeInput(property, value));
				}
			}
		}
		document.body.appendChild(form);
		form.submit();
	},
	
	focusHack : function() {
		var focusHack = document.createElement('input');
		focusHack.type = "checkbox";
		focusHack.onclick = Events.stop;
		focusHack.style.position = 'absolute';
		focusHack.style.left = '-9999px';
		focusHack.style.top = '-9999px';
		document.body.appendChild(focusHack);
		
		return focusHack;
	},
	
	getMousePos : function(e) {
		e = e || window.event;
		var top = e.pageY || e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
		var left = e.pageX || e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
		return { left: left, top: top};
	},
	
	crypt : {
		encrypt : function(cryptString, cryptKey) {
			var encrypted = '';
			for (var i=0 ; i<cryptString.length ; i++) {
				encrypted += String.fromCharCode(cryptString.charCodeAt(i) ^ cryptKey.charCodeAt(i%cryptKey.length));
			}
			return encrypted;
		},
		
		decrypt : function(cryptString, cryptKey) {
			return M.crypt.encrypt(cryptString, cryptKey);
		}
	}
};

/* Notice: Copied from Dropdown.js */
function Dropdown(itemList, container, defaultIndex) {
	this.container = container;

	this.domref = document.createElement("div");
	this.domref.className = 'dropdown';

	this.headerNode = document.createElement("div");
	this.headerNode.className = 'header';
	this.headerAnchor = document.createElement("a");
	this.headerAnchor.href = '#';
	this.domref.appendChild(this.headerNode).appendChild(this.headerAnchor);

	this.headerNode.onkeypress = M.fn.fixScope(this, function(e) {
		e = e || window.event;
		var currentIndex, newIndex;
		if (M.dom.hasClass(this.domref, 'dropped') && this.currentlyHoveredItem) {
			currentIndex = this.currentlyHoveredItem.itemIndex;
		}else{
			currentIndex = this.selectedIndex;
		}
		var ch = String.fromCharCode(e.charCode || e.keyCode).toLowerCase();
		if (/^[\u0020-\uffff]$/.test(ch)) {
			if (this.itemList[currentIndex].title.charAt(0).toLowerCase() === ch &&
				currentIndex+1 < this.itemList.length &&
				this.itemList[currentIndex+1].title.charAt(0).toLowerCase() === ch) {
				newIndex = currentIndex+1;
			}else{
				for (var i=0 ; i<this.itemList.length ; i++) {
					if (this.itemList[i].title.charAt(0).toLowerCase() === ch) {
						newIndex = i;
						break;
					}
				}
			}
		}
		if (typeof newIndex !== 'undefined') {
			if (M.dom.hasClass(this.domref, 'dropped')) {
				this.setHoveredItem(this.ul.childNodes[newIndex]);
			}else{
				this.setActiveIndex(newIndex);
			}
		}
	});

	this.headerNode.onkeydown = M.fn.fixScope(this, function(e) {
		e = e || window.event;
		var currentIndex, newIndex;
		if (M.dom.hasClass(this.domref, 'dropped') && this.currentlyHoveredItem) {
			currentIndex = this.currentlyHoveredItem.itemIndex;
		}else{
			currentIndex = this.selectedIndex;
		}
		switch (e.keyCode) {
		case 38: /* Arrow up */
		case 37: /* Arrow left */
		case 63232:
			newIndex = currentIndex - 1;
			break;
		case 40: /* Arrow down */
		case 39: /* Arrow right */
		case 63233:
			newIndex = currentIndex + 1;
			break;
		case 33: /* Page up */
		case 63276:
			newIndex = currentIndex - 10;
			break;
		case 34: /* Page down */
		case 63277:
			newIndex = currentIndex + 10;
			break;
		case 36: /* Home */
			newIndex = 0;
			break;
		case 35: /* End */
			newIndex = this.itemList.length - 1;
			break;
		case 13:
			this.setActiveIndex(currentIndex);
			/* Fall through */
		case 27:
			this.unDrop();
			return;
		default:
			return;
		}
		if (newIndex >= this.itemList.length) {
			newIndex = this.itemList.length-1;
		}
		if (newIndex < 0) {
			newIndex = 0;
		}
		if (M.dom.hasClass(this.domref, 'dropped')) {
			this.setHoveredItem(this.ul.childNodes[newIndex]);
		}else{
			this.setActiveIndex(newIndex);
		}
	});

	this.itemList = itemList;

	this.ul = document.createElement("ul");
	this.ul.className = 'dropdownList';

	for (var i=0 ; i<this.itemList.length ; i++) {
		var item = this.itemList[i];

		var a = document.createElement("a");
		a.className = item.className || '';
		a.onclick = Events.preventDefault;

		var li = document.createElement("li");
		li.itemIndex = i;
		li.className = 'notSelected';

		if (item.invisible) {
			li.className += ' invisible';
		}

		if (BO.ie || BO.opera) {
			li.unselectable = a.unselectable = "on";
		}
		this.ul.appendChild(li).appendChild(a).appendChild(document.createTextNode(item.title));
	}
	defaultIndex = defaultIndex || 0;
	this.setActiveIndex(defaultIndex);

	this.domref.onmouseover = this.domref.onmouseout = this.domref.onmousedown = this.domref.onmouseup =
		this.ul.onmouseover = this.ul.onmousedown = this.ul.onmouseup = M.fn.fixScope(this, this.eventHandler);

	if (BO.ie) {
		this.domref.ondragstart = this.domref.onselectstart =
			this.ul.ondragstart = this.ul.onselectstart = Events.stop;
		this.ul.ondblclick = this.ul.onclick;
	}

	if (BO.opera) {
		this.headerNode.unselectable = this.headerAnchor.unselectable = this.domref.unselectable = this.ul.unselectable = 'on';
	}

	this.domref.onclick = Events.stop;

	this.ul.onclick = this.ul.ondblclick = M.fn.fixScope(this, function(e) {
		e = e || window.event;
		var target = e.target || e.srcElement;
		this.headerAnchor.focus();
		return Events.stop(e);
	});
	if (this.container) {
		this.container.appendChild(this.domref);
	}
}

Dropdown.fromSelect = function(select) {
	/* For webkit browsers we will used -webkit-appearance: textarea; */
	if (BO.webkit) {return;}
	var itemList = [];
	for (var i=0 ; i<select.options.length ; i++) {
		var option = select.options[i];
		itemList.push({
			className: option.className,
			value: option.value,
			title: ((option.firstChild ? option.firstChild.nodeValue : option.value) || '').replace(/\s/g, "\u00a0")
		});
	}
	var dropdown = new Dropdown(itemList, null, select.selectedIndex);
	dropdown.domref.style.width = select.offsetWidth + (BO.safari ? 10: 3) + 'px';
	select.parentNode.insertBefore(dropdown.domref, select);
	select.style.display = 'none';
	dropdown.onChange = function(newValue) {
		select.value = newValue;
	};
	return dropdown;
};

Dropdown.prototype = {
	setActiveId : function(id, triggerOnChange) {
		for (var i=0 ; i<this.itemList.length ; i++) {
			if (id === this.itemList[i].id) {
				this.setActiveIndex(i, triggerOnChange);
				return;
			}
		}
		this.setActiveIndex(0, triggerOnChange); /* ID not recognized, select first index */
	},

	setActiveIndex : function(index, triggerOnChange) {
		if (typeof this.selectedIndex !== 'undefined') {
			if (this.selectedIndex === index) {
				return;
			}
			this.headerAnchor.removeChild(this.headerAnchor.firstChild);
			var currentlySelectedItem = this.ul.childNodes[this.selectedIndex];
			M.dom.removeClass(currentlySelectedItem, 'selected');
			M.dom.addClass(currentlySelectedItem, 'notSelected');
		}
		var previouslySelectedIndex = this.selectedIndex;
		this.selectedIndex = index;
		var selectedItem = this.ul.childNodes[this.selectedIndex];
		M.dom.removeClass(selectedItem, 'notSelected');
		M.dom.addClass(selectedItem, 'selected');
		this.value = this.itemList[this.selectedIndex].id;
		this.headerAnchor.appendChild(document.createTextNode(this.itemList[this.selectedIndex].title));

		if (previouslySelectedIndex !== this.selectedIndex && triggerOnChange !== false) {
			if (this.onChange) {
				this.onChange(this.itemList[this.selectedIndex].value);
			}
		}
	},

	setHoveredItem : function(hoveredItem) {
		if (this.currentlyHoveredItem) {
			M.dom.removeClass(this.currentlyHoveredItem, 'hover');
		}

		this.currentlyHoveredItem = hoveredItem;
		M.dom.addClass(this.currentlyHoveredItem, 'hover');

		if (this.currentlyHoveredItem.offsetTop < this.ul.scrollTop) {
			this.ul.scrollTop = this.currentlyHoveredItem.offsetTop + (BO.opera ? 0 : 1);
		}else if (this.currentlyHoveredItem.offsetTop > this.ul.offsetHeight + this.ul.scrollTop - this.itemHeight + (BO.opera ? 1 : 2)) {
			this.ul.scrollTop = this.currentlyHoveredItem.offsetTop - this.ul.offsetHeight + this.itemHeight + (BO.opera ? 1 : 2);
		}
	},

	drop : function() {
		if (this.blurTimeout) {
			clearTimeout(this.blurTimeout);
			delete this.blurTimeout;
			return;
		}
		M.dom.addClass(this.domref, 'dropped');

		this.ul.style.width = this.domref.offsetWidth + 'px';

		if (this.itemList.length > 10) {
			this.ul.style.height = 1.2 * 10 + 'em';
		}

		document.body.appendChild(this.ul);

		this.itemHeight = this.ul.firstChild.offsetHeight;
		this.numItemsPerPage = Math.floor(this.domref.offsetHeight / this.itemHeight);

		this.ul.style.left = M.dom.getOffset(this.domref, 'offsetLeft')+2 + 'px';
		this.ul.style.top = (M.dom.getOffset(this.domref, 'offsetTop') + this.domref.offsetHeight + 1) + 'px';

		if (BO.ie6) { /* Blergh. Set width on each dropdown item explicitly, otherwise the LIs won't receive events in IE6 */
			this.ie6width = this.ie6width || (this.ul.clientWidth - 2);
			var lis = this.ul.getElementsByTagName("li");
			for (var i=0 ; i<lis.length ; i++) {
				lis[i].style.width = this.ie6width + 'px';
			}
		}

		/* Use header anchor as a focus hack */
		this.headerAnchor.focus();

		this.headerAnchor.onblur = M.fn.fixScope(this, function() {
			this.unDrop();
		});

		this.setHoveredItem(this.ul.childNodes[this.selectedIndex]);
	},

	unDrop : function() {
		if (this.ignoreNextUndrop) { /* In Opera, this.headerAnchor gets blurred onmouseup for now reason */
			delete this.ignoreNextUndrop;
			return;
		}
		if (this.blurTimeout) {
			return;
		}else{
			this.blurTimeout = setTimeout(M.fn.fixScope(this, function() {
				delete this.blurTimeout;
				if (M.dom.hasClass(this.domref, 'dropped')) {
					M.dom.removeClass(this.domref, 'dropped');
					document.body.removeChild(this.ul);
				}
			}), 20);
		}
	},

	toggleDrop : function() {
		if (M.dom.hasClass(this.domref, 'dropped')) {
			this.unDrop();
		}else{
			this.drop();
		}
	},

	eventHandler : function(e) {
		e = e || window.event;
		var target = e.target || e.srcElement;
		var targetContainer;
		if (/^(?:li|div)$/i.test(target.nodeName)) {
			targetContainer = target;
		}else if (target.nodeName.toLowerCase() === 'a') {
			targetContainer = target.parentNode;
		}
		if (targetContainer === this.headerNode) {
			if (e.type === 'mouseover') {
				M.dom.addClass(this.headerNode, 'hover');
			}else if (e.type === 'mouseout') {
				M.dom.removeClass(this.headerNode, 'hover');
			}else if (e.type === 'mousedown' || e.type === 'dblclick') {
				this.toggleDrop();
			}else if (BO.opera && e.type === 'mouseup' && target === this.headerAnchor) {
				this.ignoreNextUndrop = true;
				return false;
			}
		}else if (targetContainer && targetContainer.nodeName.toLowerCase() === 'li') {
			if (e.type === 'mousedown' || e.type === 'dblclick' || e.type === 'mouseup') {
				this.setActiveIndex(targetContainer.itemIndex);
				this.unDrop();
			}else if (e.type === 'mouseover') {
				this.setHoveredItem(targetContainer);
			}
		}else if (e.type === 'mousedown' || e.type === 'dblclick' && target === this.ul) {
			setTimeout(M.fn.fixScope(this, function() {
				if (this.blurTimeout) {
					clearTimeout(this.blurTimeout);
					delete this.blurTimeout;
				}
			}), 0);
			this.headerAnchor.focus();
			return true;
		}
		Events.stopPropagation(e);
		return false;
	},

	destruct : function() {
		this.ul = this.container = this.domref = this.headerNode = this.domref.onkeydown =
			this.domref.onmouseover = this.domref.onmouseout = this.domref.onmousedown = this.domref.onmouseup =
			this.ul.ondblclick = this.ul.onmouseover = this.ul.onmousedown = this.ul.onmouseup = this.onChange = null;
	}
};